require("AnAL")

function love.load()

gamestate = "menue"

--Highscore Laden
love.filesystem.setIdentity( "prscore.lua" )
hs = love.filesystem.read( "prscore.lua" )
hs = tonumber( hs )

--Animation
local runner  = love.graphics.newImage("grafiken/runner/runner.png")
animrunner = newAnimation(runner, 20, 36, 0.1, 0)
local runnerdown  = love.graphics.newImage("grafiken/runner/runnerdown.png")
animrunnerdown = newAnimation(runnerdown, 20, 36, 0.1, 0)
local wall  = love.graphics.newImage("grafiken/wall.png")
animwall = newAnimation(wall, 200, 400, 0.1, 0)


--Grafiken#
start = love.graphics.newImage( "grafiken/start.png" )
starthover = love.graphics.newImage( "grafiken/starthover.png" )
exitbutton = love.graphics.newImage( "grafiken/exit.png" )
exithover = love.graphics.newImage( "grafiken/exithover.png" )
bg = love.graphics.newImage( "grafiken/bg.png" )
blockbg = love.graphics.newImage( "grafiken/blockbg.png" )
star1bg = love.graphics.newImage( "grafiken/star1bg.png" )
blockbgmirror = love.graphics.newImage( "grafiken/blockbgmirror.png" )
runnerjump = love.graphics.newImage( "grafiken/runner/jump.png" )
runnerjumpdown = love.graphics.newImage( "grafiken/runner/jumpdown.png" )

-- Schriftarten
scorefont = love.graphics.newFont("/pixel.ttf", 20)

   player = {
      x = 200,
      y = 300,
      ySpeed = 100, -- the Speed we'll add to the Y movement
      gravSecond = 3, -- gravity amount
      inAir = false
      }
	
	ground = 330
	abstand = 100
	scoreprint = ""
	--highscore =  "Highscore: " .. hs .. " "
	--highscore =  "Highscore: 1234"
	
	
	score = 0
	timec = 0
	
	obj = 0
	aw = 20
	ah = 40
	oaw = 20
	oah = 20
	
	bg1x1 = 0
	bg1x2 = 2000
	bg2x1 = 0
	bg2x2 = 2000
	bg3x1 = 0
	bg3x2 = 2000
	
	-- Test
	ax2 = 0
	ay2 = 0
	bx2 = 1
	by2 = 1
	
	bgx = 0
	bgy1 = 0
	bgy2 = -1080
	
	--anzahl = math.random( 1, 25 )
	anzahl = 10
	boxspeed = 375
	x = {}
	y = {}
	s = {}
	c1 = {}
	c2 = {}
	c3 = {}

	
	--Objekte erzeugen
    for i = 1, anzahl do
        x[i] = math.random( 800/abstand, 2500/abstand )*abstand 
        --y[i] = math.random( 100, 500 )
		y[i] = 350
		s[i] = boxspeed
		c1[i] = math.random( 1, 255 )
		c2[i] = math.random( 1, 255 )
		c3[i] = math.random( 1, 255 )
		
    end
end



function love.keypressed(key)
   if key == "up" and player.y < 330 and not player.inAir   then
      player.ySpeed = -20
      player.inAir = true
	elseif key == " " and player.y < 330 and not player.inAir   then
      player.ySpeed = -20
      player.inAir = true
   end
   
   
   if key == "escape" then gamestate = "menue"  end
end


function love.update(dt)
	--Animieren
	animrunner:update(dt) 
	animrunnerdown:update(dt)
	animwall:update(dt) 
	--Wandfarbe
	timec = timec + dt
	--Hintergrnde
	bg1x1 = bg1x1-150*dt
	bg1x2 = bg1x2-150*dt
	

	if bg1x1 <= -2000 then
	bg1x1 = 2000
	end
	if bg1x2 <= -2000  then
	bg1x2 = 2000
	end
	
	bg2x1 = bg2x1-100*dt
	bg2x2 = bg2x2-100*dt
	
	if bg2x1 <= -2000 then
	bg2x1 = 2000
	end
	if bg2x2 <= -2000  then
	bg2x2 = 2000
	end
	
	bg3x1 = bg3x1-120*dt
	bg3x2 = bg3x2-120*dt
	
	if bg3x1 <= -2000 then
	bg3x1 = 2000
	end
	if bg3x2 <= -2000  then
	bg3x2 = 2000
	end

	
   frame = dt * 30 
   
   player.ySpeed = player.ySpeed + player.gravSecond * frame
   player.y = player.y + player.ySpeed * frame
   
   if player.y > 330 then
      player.y = player.y - player.ySpeed * frame
      player.ySpeed = 0
      player.inAir = false
   end
   ------------------------------------------------------------------
   ---------------------------------------------------GAMESTATE MENUE
   ------------------------------------------------------------------
   
	mx = love.mouse.getX( )
	my = love.mouse.getY( )
	-- Start Button
	ax = 600
	ay = 300
	
	axl = ax+190
	ayl = ay+45
	
		if mx > ax and mx < axl and my > ay and my < ayl then
		coll1 = "true"
		buttonstart = starthover
		else
		coll1 = "false"
		buttonstart = start
	end
	-- Exit Button
	bx = 400
	by = 300
	
	bxl = bx+190
	byl = by+45
	
		if mx > bx and mx < bxl and my > by and my < byl then
		coll2 = "true"
		buttonexit = exithover
		else
		coll2 = "false"
		buttonexit = exitbutton
	end
	
	if love.mouse.isDown( "l" ) and coll1 == "true" then
	gamestate = "game"
	score = 0
	player.x = 200
	elseif love.mouse.isDown( "l" ) and coll2 == "true" then
	love.event.quit( )
	end
   
   --buttonstart = start
   --buttonexit = exitbutton
   
    ----------------------------------------------------------------
	--------------------------------------------------GAMESTATE GAME
	----------------------------------------------------------------
if gamestate == "game" then
   
   --Objekte Bewegen
    for i = 1, anzahl do
        x[i] = x[i]-s[i]*dt
    end

   
   --Treffer Checken
   
   i = 1
   while i <= anzahl do

	axl = x[i]+aw
	ayl = y[i]+ah

	ax2 = player.x + aw
	ay2 = player.y + ah
	bx2 = x[i] + oaw
	by2 = y[i] + oah

	
	 if player.x < bx2 and ax2 > x[i] and player.y < by2 and ay2 > y[i] then
	 player.x = player.x-5 -- Spieler zurckversetzen
	 		x[i] = math.random( 800/abstand, 2500/abstand )*abstand 
			y[i] = 350
			


	end


	
	if x[i] <= 0 then
	score = score+5 -- Punkte hinzufgen
	 		x[i] = math.random( 800/abstand, 2500/abstand )*abstand 
			y[i] = 350
	end
	

	 
	i = i+1
end
	
	--Bei Niederlage
	if player.x <= 0 then
	scoreprint = "Score: " .. score .. " "
	gamestate = "menue"
		
		hs = tonumber( hs )
		if score > hs then
		hs = love.filesystem.read( "prscore.lua")
		hs = tonumber( hs )
		newcontent = love.filesystem.write(  "prscore.lua", score)
		hs = love.filesystem.read( "prscore.lua")
		end
		
			--Objekte erzeugen
		for i = 1, anzahl do
        x[i] = math.random( 800/abstand, 2500/abstand )*abstand 
        --y[i] = math.random( 100, 500 )
		y[i] = 350
		s[i] = boxspeed
		c1[i] = math.random( 1, 255 )
		c2[i] = math.random( 1, 255 )
		c3[i] = math.random( 1, 255 )
		
    end
		
	end


end
end



function love.draw()
love.graphics.draw(star1bg , bg2x1 , 0)
love.graphics.draw(star1bg , bg2x2 , 0)
love.graphics.draw(star1bg , bg3x1 , 0)
love.graphics.draw(star1bg , bg3x2 , 0)
love.graphics.draw(blockbg , bg1x1 , 50)
love.graphics.draw(blockbg , bg1x2 , 50)
love.graphics.draw(blockbgmirror , bg1x1 , 251)
love.graphics.draw(blockbgmirror , bg1x2 , 251)

	love.graphics.setColor(255,255,255)
    --love.graphics.rectangle("fill", player.x, player.y, aw, ah) -- Draw it!
	--love.graphics.setColor( 123,123,123)
	if player.inAir then
	love.graphics.draw(runnerjump , player.x , player.y+4)
love.graphics.draw(runnerjumpdown , player.x , -player.y+701)
	else
	animrunner:draw(player.x, player.y+4)
	animrunnerdown:draw(player.x, -player.y+701)
	end
	  
	  
	      i = 1
	while i <= anzahl do
        love.graphics.setColor( c1[i],c2[i],c3[i] )
        love.graphics.rectangle( "fill", x[i], y[i], oaw, oaw )
		love.graphics.rectangle( "fill", x[i], y[i]+21, oaw, oaw )
	i = i+1
    end
	love.graphics.setColor(math.floor((math.sin(timec))*255),math.floor(math.abs(math.sin(timec))*255),math.floor(math.abs(math.cos(timec))*255),255)
	animwall:draw(0, 0)
		-- Background
		
	love.graphics.setColor(255,255,255)
	love.graphics.draw(bg , 0 , 0)
	
	--gui
	if gamestate == "game" then
	love.graphics.setColor(255,100,0)
	love.graphics.rectangle( "fill", 650, 0, 150, 20 )
	love.graphics.setColor(0,0,255)
	love.graphics.setFont(scorefont);
	love.graphics.printf("Score: " .. score .. " ", 550, 3, 250, 'right')
	end
	
	love.graphics.setColor(255,255,255)
	
	if gamestate == "menue" then
	love.graphics.draw(buttonstart , 600 , 300)
	love.graphics.draw(buttonexit , 400 , 300)
	love.graphics.setColor(123,255,255)
	love.graphics.rectangle( "fill", 400, 355, 390, 30 )
	love.graphics.setColor(000,000,000)
	love.graphics.setFont(scorefont);
	love.graphics.print("Highscore: " .. hs .. " ", 405, 362)
	--love.graphics.printf(highscore, 405, 362, 390, 'left')
	if player.x <= 0 then
	love.graphics.printf(scoreprint, 610, 362, 390, 'left')
	end
	love.graphics.setColor(255,255,255)
	end


end
